import { renderless, api } from '@opentinyvue/vue-renderless/skeleton/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import SkeletonItem from '@opentinyvue/vue-skeleton-item';
import { resolveComponent, openBlock, createElementBlock, renderSlot, createElementVNode, createBlock, createCommentVNode, createVNode, Fragment, renderList, normalizeStyle } from 'vue';

function _createForOfIteratorHelperLoose(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (t) return (t = t.call(r)).next.bind(t);
  if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) {
    t && (r = t);
    var o = 0;
    return function() {
      return o >= r.length ? { done: true } : { done: false, value: r[o++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  emits: ["update:modelValue"],
  props: [].concat(props, ["modelValue", "loading", "rows", "avatar", "rowsWidth", "animated"]),
  components: {
    TinySkeletonItem: SkeletonItem
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  class: "tiny-skeleton"
};
var _hoisted_2 = {
  class: "tiny-skeleton__article"
};
var _hoisted_3 = {
  class: "tiny-skeleton__section"
};
var _hoisted_4 = {
  class: "tiny-skeleton-item__rows"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_tiny_skeleton_item = resolveComponent("tiny-skeleton-item");
  return openBlock(), createElementBlock("div", _hoisted_1, [_ctx.loading ? renderSlot(_ctx.$slots, "placeholder", {
    key: 0
  }, function() {
    return [createElementVNode("div", _hoisted_2, [_ctx.avatar ? (openBlock(), createBlock(_component_tiny_skeleton_item, {
      key: 0,
      variant: "circle",
      class: "tiny-skeleton__avatar"
    })) : createCommentVNode("v-if", true), createElementVNode("div", _hoisted_3, [createVNode(_component_tiny_skeleton_item, {
      class: "tiny-skeleton-item__title"
    }), createElementVNode("div", _hoisted_4, [(openBlock(true), createElementBlock(
      Fragment,
      null,
      renderList(_ctx.rows, function(item, index) {
        return openBlock(), createBlock(_component_tiny_skeleton_item, {
          key: item,
          style: normalizeStyle({
            width: _ctx.toPxStyle(_ctx.rowsWidth[index])
          })
        }, null, 8, ["style"]);
      }),
      128
      /* KEYED_FRAGMENT */
    ))])])])];
  }) : renderSlot(_ctx.$slots, "default", {
    key: 1
  })]);
}
var pc = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);

export { pc as default };
